PROGRAM makesignals;
USES constsU,sysutils;

CONST slen=1000;

    trennung=165;
    linestart=41; 
      

VAR f,flp:text;
   ay,au,av:ARRAY[0..slen-1] OF double;
   linecounter:integer;

FUNCTION sinx(x:double):double;
BEGIN
  IF abs(x)<1e-5 THEN sinx:=1 
		 ELSE sinx:=sin(x)/x;
END;


PROCEDURE writeline(pol:integer;name:string;start,stop:integer);
VAR s:string;
    n,m,an,x:integer;
    su,sv:double;
    rest:integer;
    samples:ARRAY[0..slen-1] OF integer;
BEGIN
  palline:=pol;
  sphase:=0;  
 FOR n:=1 TO slen-1 DO
 BEGIN
    samples[n]:=modul(ay[n],(au[n]+au[n-1])/2,(av[n]+av[n-1])/2);
 END;
// samples[slen-1]:=10;
  an:=start;
  FOR n:=start+1 TO stop DO
  BEGIN
    IF (samples[an]<>samples[n]) OR (n>=stop) THEN
    BEGIN
      writesample(f,samples[an],an);
      rest:=(n-an)-1;
      while (rest>100) DO
      BEGIN
        writeln(f,'  call delay_100');
        rest:=rest-100;
      END;
      while (rest=50) OR (rest>=70) DO
      BEGIN
        writeln(f,'  call delay_50');
        rest:=rest-50;
      END;
      while (rest=30) OR (rest>=50) DO
      BEGIN
        writeln(f,'  call delay_30');
        rest:=rest-30;
      END;
      while (rest>=8) DO
      BEGIN
        x:=rest;
        IF x>29 THEN x:=29;
        writeln(f,'  call delay_',x);
        rest:=rest-x;
      END;
      FOR x:=n-rest TO n-1 DO
        writeln(f,'  nop ;',x);
//         writesample(samples[x],x);
      an:=n;  
    END;
  END;
  FOR x:=an TO stop DO
    writesample(f,samples[x],x);
  writeln(f,'ret');
END;


PROCEDURE writelinepointers(name:string);
VAR n:integer;
BEGIN
  write(flp,'.dw ');
  FOR n:=0 TO 3 DO
  BEGIN
    write(flp, name,'_',n);
    IF n<>3 THEN write(flp,',');
  END;
  writeln(flp);
  writeln(flp,'.equ ',name,'=',linecounter);
  inc(linecounter);
END;



PROCEDURE writefulllinecode(name:string);
VAR n:integer;
BEGIN
  FOR n:=0 TO 3 DO
  BEGIN
    writeln(f,name,'_mb_',n,':');
    writeln(f,'   LDI r30,30');
    writeln(f,'   LDI r31,31');
    writeln(f,'   call burst_',n);
    writeln(f,'   jmp ',name,'_',n);
    writeln(f,'  ret');
  END;
  writelinepointers(name+'_mb');
END;


PROCEDURE writelinefull(name:string);
BEGIN
  writeln(f,name,'_0:');
  writeline(0,name,trennung,slen-1);
  writeln(f,name,'_1:');
  writeline(1,name,trennung,slen-1);
  writeln(f,name,'_2:');
  writeline(2,name,trennung,slen-1);
  writeln(f,name,'_3:');
  writeline(3,name,trennung,slen-1);
  writefulllinecode(name);
END;

PROCEDURE writelinemono(name:string);
BEGIN
  writeln(f,name,'_0:');
  writeln(f,name,'_2:');
  writeln(f,name,'_1:');
  writeln(f,name,'_3:');
  writeline(0,name,trennung,slen-1);
  writefulllinecode(name);
{writelinefull(name);}
END;

PROCEDURE writelinenoburst(name:string;ende:integer);
BEGIN
  writeln(f,name,'_0:');  
  writeln(f,name,'_1:');
  writeln(f,name,'_2:');
  writeln(f,name,'_3:');
  writeline(-1,name,linestart,ende);
  writelinepointers(name);
END;


PROCEDURE fill(start,stop:integer;y,u,v:double);
VAR n:integer;
BEGIN
  FOR n:=start TO stop DO
  BEGIN
    ay[n]:=y;
    au[n]:=u;
    av[n]:=v;
  END;
END;

PROCEDURE emptyline;
BEGIN
  fill(0,slen-1,black,0,0);
END;

PROCEDURE machburst_hsync;
BEGIN
  fill(0,75,sync,0,0);
  fill(90,126,black,-0.106,0.106);
END;


PROCEDURE hsync_burst;
BEGIN
  emptyline;
  machburst_hsync;
  writeln(f,'burst_0:');
  writeline(0,'',linestart,trennung-8); 
  writeln(f,'burst_2:');
  writeline(2,'',linestart,trennung-8);
  writeln(f,'burst_1:');
  writeline(1,'',linestart,trennung-8);
  writeln(f,'burst_3:');
  writeline(3,'',linestart,trennung-8);
END;

PROCEDURE fillcolour(start,stop:integer;r,g,b:double);
VAR y,u,v:double;
BEGIN
  y:=0.299*r+0.587*g+0.114*b;
  u:=0.493*(b-y);
  v:=0.877*(r-y);
  fill(start,stop,(y*(white-black))+black,u,v);
END;


PROCEDURE mbburst(von,bis:integer; freq:double);
VAR n:integer;
BEGIN
  FOR n:=von TO bis DO
    fill(n,n,(sin(n/fclk*2*pi*freq)*0.5+0.5)*(white-black)+black,0,0);
END;


PROCEDURE grid;
VAR n:integer;
BEGIN
  fill(166,998,black+0.1*white,0,0);
  FOR n:=-10 TO 10 DO
    fill(582+n*40,582+n*40+1,white,0,0);
END;

PROCEDURE cbars;
BEGIN
  fillcolour(344,403,0.75,0.75,0.75);
  fillcolour(404,463,0.75,0.75,0   );
  fillcolour(464,523,0   ,0.75,0.75);
  fillcolour(524,583,0   ,0.75,0   );
  fillcolour(584,643,0.75,0   ,0.75);
  fillcolour(644,703,0.75,0   ,0   );
  fillcolour(704,763,0   ,0   ,0.75);
  fillcolour(764,821,0   ,0   ,0   );
END;

PROCEDURE gbars;
BEGIN
  fillcolour(344,439,0  ,0  ,0  );
  fillcolour(439,534,0.25,0.25,0.25);
  fillcolour(534,631,0.5,0.5,0.5);
  fillcolour(632,726,0.75,0.75,0.75);
  fillcolour(727,822,1,1,1);
  fill(582,582+1,white,0,0);
END;

PROCEDURE gridline; //Muster mit vertikalen Gitterlinien im Hintergrund
VAR n:integer;
    f:double;
BEGIN
  emptyline;
  machburst_hsync;
  grid;
  writelinemono('grid');
  cbars;
  writelinefull('cbars');
  gbars;
  writelinemono('gbars');

  fill(344,821,black+0.5*(white-black),0,0);
  fill(344,420,white,0,0);
  mbburst(430,470,1e6);
  mbburst(480,520,2e6);
  mbburst(530,570,3e6);

  mbburst(650,690,4e6);
  mbburst(700,740,4.443e6);
  mbburst(750,790,4.886e6);
  fill(582,584,white,0,0);
  writelinemono('mburst');
  fill(344,821,white,0,0);
  writelinemono('grid_w');
  fill(439,727,black,0,0);
//  writelinemono('grid_b');

  fill(344,822,white*0.5+black,0,0);
  FOR n:=344 TO 662 DO
  BEGIN
    f:=(622-n)/(622-344);
    fill(n,n,white*0.375*f+black,0,0.55*f);
  END;
  fill(662,742,white*0.5+black,0,0.5);
  fill(742,822,white*0.5+black,0.5,0);
  writelinefull('uvr_e');
  fill(662,742,white*0.5+black,0,-0.5);
  fill(742,822,white*0.5+black,-0.5,0);
  writelinefull('uvr_o');

  fill(344,822,white*0.5+black,0,0);
  FOR n:=344 TO 662 DO
  BEGIN
    f:=(622-n)/(622-344);
    fill(n,n,white*0.375*f+black,0.55*f,0);
  END;
  fill(662,742,white*0.5+black,0,0.5);
  fill(742,822,white*0.5+black,0.5,0);
  writelinefull('uvb_e');
  fill(662,742,white*0.5+black,0,-0.5);
  fill(742,822,white*0.5+black,-0.5,0);
  writelinefull('uvb_o');

  FOR n:=0 TO 4 DO
  BEGIN
    fill(344,822,white,0,0);
    fill(582-7,582-7+round((5-n)/5*15),black,0,0);
    writelinemono('keil_'+inttostr(n));
  END;
END;

PROCEDURE gridlineh;  //Muster mit horizontalen Gitterlinien im Hintergrund
BEGIN
  emptyline;
  machburst_hsync;
  fill(166,998,white,0,0);
  cbars;
  writelinefull('cbarsl');
  gbars;
  writelinemono('gbarsl');
END;


PROCEDURE colourline(y,u,v:double;name:string);
BEGIN
  emptyline;
  machburst_hsync;
  fill(166,998,y,u,v);
  writelinemono(name);
END;

PROCEDURE vsync;
BEGIN
  emptyline;
  fill(0,37,sync,0,0);
  fill(512,549,sync,0,0);
  writelinenoburst('vsync_trab',slen-1); //2 Trabanten
  emptyline;
  fill(0,37,sync,0,0);
  fill(512,949,sync,0,0);
  writelinenoburst('vsync_trab_vsync',slen-1);
  emptyline;
  fill(0,436,sync,0,0);
  fill(512,949,sync,0,0);
  writelinenoburst('vsync_vsync',slen-1);
  emptyline;
  fill(0,436,sync,0,0);
  fill(512,549,sync,0,0);
  writelinenoburst('vsync_vsync_trab',slen-1);

  emptyline;
  machburst_hsync; //hsync
  fill(512,549,sync,0,0); //1. Vortrabant
  writelinenoburst('vsync_hsync_trab',slen-1);
  writelinenoburst('vsync_hsync_trab_lz',slen-1-3);
END;




BEGIN
  assign(f,'samples.inc');
  rewrite(f);
  assign(flp,'linepointers.inc');
  rewrite(flp);
  writeln(flp,'linepointers:');
  linecounter:=0;
  vsync;
  hsync_burst;
  colourline(black,0,0,'black');
  colourline(white,0,0,'white');
  gridline;
  gridlineh;
  writelinepointers('grid_b_mb');
writelinepointers('grid_t_mb');
  close(f);
  close(flp);
END.
